/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
	"fmt"
)

// WebhookRequest struct for WebhookRequest
type WebhookRequest struct {
	AddReceiptWebhook *AddReceiptWebhook
	GetReceiptWebhook *GetReceiptWebhook
}

// Unmarshal JSON data into any of the pointers in the struct
func (dst *WebhookRequest) UnmarshalJSON(data []byte) error {
	var err error
	// try to unmarshal JSON data into AddReceiptWebhook
	err = json.Unmarshal(data, &dst.AddReceiptWebhook);
	if err == nil {
		jsonAddReceiptWebhook, _ := json.Marshal(dst.AddReceiptWebhook)
		if string(jsonAddReceiptWebhook) == "{}" { // empty struct
			dst.AddReceiptWebhook = nil
		} else {
			return nil // data stored in dst.AddReceiptWebhook, return on the first match
		}
	} else {
		dst.AddReceiptWebhook = nil
	}

	// try to unmarshal JSON data into GetReceiptWebhook
	err = json.Unmarshal(data, &dst.GetReceiptWebhook);
	if err == nil {
		jsonGetReceiptWebhook, _ := json.Marshal(dst.GetReceiptWebhook)
		if string(jsonGetReceiptWebhook) == "{}" { // empty struct
			dst.GetReceiptWebhook = nil
		} else {
			return nil // data stored in dst.GetReceiptWebhook, return on the first match
		}
	} else {
		dst.GetReceiptWebhook = nil
	}

	return fmt.Errorf("data failed to match schemas in anyOf(WebhookRequest)")
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src *WebhookRequest) MarshalJSON() ([]byte, error) {
	if src.AddReceiptWebhook != nil {
		return json.Marshal(&src.AddReceiptWebhook)
	}

	if src.GetReceiptWebhook != nil {
		return json.Marshal(&src.GetReceiptWebhook)
	}

	return nil, nil // no data in anyOf schemas
}

type NullableWebhookRequest struct {
	value *WebhookRequest
	isSet bool
}

func (v NullableWebhookRequest) Get() *WebhookRequest {
	return v.value
}

func (v *NullableWebhookRequest) Set(val *WebhookRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookRequest(val *WebhookRequest) *NullableWebhookRequest {
	return &NullableWebhookRequest{value: val, isSet: true}
}

func (v NullableWebhookRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


